// demoDoc.cpp : implementation of the CDemoDoc class
//

#include "stdafx.h"
#include "demo.h"

#include "MainFrm.h"
#include "demoDoc.h"

#include "ximage.h"
#include "ximamng.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/**************************************/
// CDemoDoc

IMPLEMENT_DYNCREATE(CDemoDoc, CDocument)

BEGIN_MESSAGE_MAP(CDemoDoc, CDocument)
	//{{AFX_MSG_MAP(CDemoDoc)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_COMMAND(ID_STRETCH_MODE, OnStretchMode)
	ON_UPDATE_COMMAND_UI(ID_STRETCH_MODE, OnUpdateStretchMode)
	ON_COMMAND(ID_WINDOW_DUPLICATE, OnWindowDuplicate)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_VIEW_ZOOMIN, OnViewZoomin)
	ON_COMMAND(ID_VIEW_ZOOMOUT, OnViewZoomout)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOMIN, OnUpdateViewZoomin)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOMOUT, OnUpdateViewZoomout)
	ON_COMMAND(ID_VIEW_NORMALVIEWING11, OnViewNormalviewing11)
	ON_UPDATE_COMMAND_UI(ID_VIEW_NORMALVIEWING11, OnUpdateViewNormalviewing11)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_COMMAND(ID_CXIMAGE_PAUSEANIMATION, OnCximagePauseanimation)
	ON_COMMAND(ID_CXIMAGE_RESUMEANIMATION, OnCximageResumeanimation)
	ON_COMMAND(ID_CXIMAGE_SINGLESTEP, OnCximageSinglestep)
	ON_COMMAND(ID_CXIMAGEMNG_SPEED_SLOW, OnCximagemngSpeedSlow)
	ON_COMMAND(ID_CXIMAGEMNG_SPEED_FAST, OnCximagemngSpeedFast)
	ON_COMMAND(ID_CXIMAGEMNG_SPEED_NORMAL, OnCximagemngSpeedNormal)
	ON_UPDATE_COMMAND_UI(ID_CXIMAGE_PAUSEANIMATION, OnUpdateCximagePauseanimation)
	ON_UPDATE_COMMAND_UI(ID_CXIMAGE_SINGLESTEP, OnUpdateCximageSinglestep)
	ON_UPDATE_COMMAND_UI(ID_CXIMAGE_RESUMEANIMATION, OnUpdateCximageResumeanimation)
	ON_COMMAND(ID_CXIMAGE_SETTRANSPARENCY, OnCximageSettransparency)
	ON_UPDATE_COMMAND_UI(ID_CXIMAGE_SETTRANSPARENCY, OnUpdateCximageSettransparency)
	ON_COMMAND(ID_CXIMAGE_REMOVETRANSPARENCY, OnCximageRemovetransparency)
	ON_UPDATE_COMMAND_UI(ID_CXIMAGE_REMOVETRANSPARENCY, OnUpdateCximageRemovetransparency)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/**************************************/
unsigned long _stdcall RunMNGThread(void *lpParam)
{
	CDemoDoc *pDoc = (CDemoDoc *)lpParam;
	POSITION pos;
	CView *pView;
	Sleep((DWORD)(pDoc->image->mnginfo.delay / pDoc->image->mnginfo.speed));
	try {
		while (pDoc->image->mnginfo.animation_enabled && pDoc->image->Resume()){
			pos = pDoc->GetFirstViewPosition();
			pView = pDoc->GetNextView(pos);
			if (pView) SendMessage(pView->m_hWnd, WM_USER_NEWIMAGE,0,0);
			Sleep((DWORD)(pDoc->image->mnginfo.delay / pDoc->image->mnginfo.speed));
		}
	} catch (int err) {
		pDoc->image->mnginfo.thread=0;
		return err;
	}
	pDoc->image->mnginfo.thread=0;
	return 0;
}

/**************************************/
// CDemoDoc construction/destruction
CDemoDoc::CDemoDoc()
{
	image = NULL;
	m_WaitingClick=stretchMode = FALSE;
	m_ZoomFactor=1;
	QueryPerformanceFrequency(&m_swFreq);
	m_etime = 0.0;
}
/**************************************/
CDemoDoc::~CDemoDoc()
{
	// free objects
	delete image;
}
/**************************************/
BOOL CDemoDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument()) return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	image = NULL;

	return TRUE;
}
/**************************************/
// CDemoDoc serialization
void CDemoDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())	{ } 
	else { }
}
/**************************************/
// CDemoDoc diagnostics
#ifdef _DEBUG
void CDemoDoc::AssertValid() const
{
	CDocument::AssertValid();
}
/**************************************/
void CDemoDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
/**************************************/
// CDemoDoc commands
static CString FindExtension(const CString& name)
{
	int len = name.GetLength();
	int i;
	for (i = len-1; i >= 0; i--){
		if (name[i] == '.'){
			return name.Mid(i+1);
		}
	}
	return CString("");
}
/**************************************/
BOOL CDemoDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	CString filename(lpszPathName);
	CString ext(FindExtension(filename));
	ext.MakeLower();
	if (ext == "") return FALSE;

	int type = 0;
	if (0) type = 0;
#if CXIMAGE_SUPPORT_MNG
	else if (ext=="mng"||ext=="png"||ext=="jng")	type = CXIMAGE_FORMAT_MNG;
#endif
	else return FALSE;

	Stopwatch(0);
	image = new CxImageMNG();
	if (type == CXIMAGE_FORMAT_MNG){
		image->ReadFile(filename);
	} else {
		image->CxImage::ReadFile(filename, type);
	}
	Stopwatch(1);

	if (!image->IsValid()){
		AfxMessageBox(image->GetLastError());
		delete image;
		image = NULL;
		return FALSE;
	}

	UpdateAllViews(NULL,WM_USER_NEWIMAGE);

	if (image->mnginfo.animation) {
		image->mnginfo.animation_enabled=1;
		DWORD dwID;
		image->mnginfo.thread = CreateThread(NULL,0,RunMNGThread,this,0,&dwID);
	}

	return TRUE;
}
/**************************************/
BOOL CDemoDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	CString filename(lpszPathName);
	CString ext(FindExtension(filename));
	ext.MakeLower();
	if (ext == "") return FALSE;

	int type = 0;
	if (0) type = 0;
#if CXIMAGE_SUPPORT_MNG
	else if (ext == "mng")				type = CXIMAGE_FORMAT_MNG;
#endif
	else return FALSE;

	bool retval;
	Stopwatch(0);
	retval = image->CxImage::SaveFile(filename, type);
	Stopwatch(1);
	UpdateStatusBar();
	if (retval) return TRUE;
	AfxMessageBox(image->GetLastError());

	return FALSE;
}
/**************************************/
BOOL CDemoDoc::DoSave(LPCTSTR pszPathName, BOOL bReplace /*=TRUE*/)
{
	if (!image)	return FALSE;

	CString newName = pszPathName;
	BOOL bModified = IsModified();

	BOOL bSaveAs = FALSE;
	if (newName.IsEmpty()) bSaveAs = TRUE;
	else if (!theApp.GetWritableType(image->GetType()))	bSaveAs = TRUE;

	if (bSaveAs){
		newName = m_strPathName;
		if (bReplace && newName.IsEmpty()){
			newName = m_strTitle;
			int iBad = newName.FindOneOf(_T(" #%;/\\"));    // dubious filename
			if (iBad != -1)	newName.ReleaseBuffer(iBad);

			// append the default suffix if there is one
			newName += theApp.GetExtFromType(image->GetType()).Mid(1,4);
		}

		int nDocType = image->GetType();
		if (!theApp.PromptForFileName(newName, 
			bReplace ? AFX_IDS_SAVEFILE : AFX_IDS_SAVEFILECOPY,
			OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, FALSE, &nDocType))
		{
			return FALSE;       // don't even try to save
		}
	}

	BeginWaitCursor();
	if (!OnSaveDocument(newName)){
		if (pszPathName == NULL){
			// be sure to delete the file
			TRY 
			{
				CFile::Remove(newName);
			}
			CATCH_ALL(e)
			{
				TRACE0("Warning: failed to delete file after failed SaveAs\n");
			}
			END_CATCH_ALL
		}
		EndWaitCursor();
		return FALSE;
	}

	EndWaitCursor();
	if (bReplace) {
		// Reset the title and change the document name
		SetPathName(newName, TRUE);
		ASSERT(m_strPathName == newName); // must be set
	}
	else // SaveCopyAs
	{
		SetModifiedFlag(bModified);
	}
	return TRUE;        // success
}
/**************************************/
void CDemoDoc::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(image!=0);
}
/**************************************/
void CDemoDoc::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(0);
//	pCmdUI->Enable((image != NULL)); //&& theApp.GetWritableType(image->GetType()));
}
/**************************************/
void CDemoDoc::OnStretchMode() 
{
	stretchMode = !stretchMode;
	UpdateAllViews(NULL);
}
/**************************************/
void CDemoDoc::OnUpdateStretchMode(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(stretchMode);
}
/**************************************/
void CDemoDoc::OnWindowDuplicate() 
{
	CDemoDoc *NewDoc=(CDemoDoc*)((CDemoApp*)AfxGetApp())->demoTemplate->OpenDocumentFile(NULL); 

	if (NewDoc)	{
		CxImageMNG *newImage = new CxImageMNG();
		newImage->Copy(image);

		NewDoc->image = newImage;

		CString s;
		s.Format("Copy %d of %s",((CDemoApp*)AfxGetApp())->m_nDocCount++,GetTitle());
		NewDoc->SetTitle(s);
		NewDoc->UpdateAllViews(0,WM_USER_NEWIMAGE);
	}
}
/**************************************/
void CDemoDoc::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	if (image==NULL) pCmdUI->Enable(0);
}
/**************************************/
void CDemoDoc::OnEditCopy() 
{
	HANDLE hDIB=image->CopyToHandle();

	if (::OpenClipboard(AfxGetApp()->m_pMainWnd->GetSafeHwnd())) {
		if(::EmptyClipboard()) {
			if (::SetClipboardData(CF_DIB,hDIB) == NULL ) {
				AfxMessageBox( "Unable to set Clipboard data" );
			}
		}
	}
	CloseClipboard();
}
/**************************************/
void CDemoDoc::UpdateStatusBar()
{
	if (image){
		CStatusBar& statusBar = ((CMainFrame *)(AfxGetApp()->m_pMainWnd))->GetStatusBar();
		CString s;
		s.Format("(%dx%dx%d)",image->GetWidth(),image->GetHeight(),image->GetBpp());
		statusBar.SetPaneText(3, s);
		s.Format("Time (s): %.3f",m_etime);
		statusBar.SetPaneText(2, s);

		((CMainFrame *)(AfxGetApp()->m_pMainWnd))->GetProgressBar().SetPos(0);
	}
}
/**************************************/
void CDemoDoc::OnViewZoomin() 
{
	if (m_ZoomFactor>=16) return;
	m_ZoomFactor*=2;
	UpdateAllViews(NULL,WM_USER_NEWIMAGE);
}
/**************************************/
void CDemoDoc::OnViewZoomout() 
{
	if (m_ZoomFactor<=0.0625) return;
	m_ZoomFactor/=2;
	UpdateAllViews(NULL,WM_USER_NEWIMAGE);
}
/**************************************/
void CDemoDoc::OnUpdateViewZoomin(CCmdUI* pCmdUI) 
{
	if (stretchMode) pCmdUI->Enable(0);
	if (m_ZoomFactor>=8) pCmdUI->Enable(0);
}
/**************************************/
void CDemoDoc::OnUpdateViewZoomout(CCmdUI* pCmdUI) 
{
	if (stretchMode) pCmdUI->Enable(0);
	if (m_ZoomFactor<=0.125) pCmdUI->Enable(0);
}
/**************************************/
void CDemoDoc::OnViewNormalviewing11() 
{
	m_ZoomFactor=1;
	UpdateAllViews(NULL,WM_USER_NEWIMAGE);
}
/**************************************/
void CDemoDoc::OnUpdateViewNormalviewing11(CCmdUI* pCmdUI) 
{
	if (stretchMode) pCmdUI->Enable(0);
	if (m_ZoomFactor==1) pCmdUI->Enable(0);
}
/**************************************/
void CDemoDoc::Stopwatch(int start0stop1)
{
	if (start0stop1==0)	QueryPerformanceCounter(&m_swStart);
	else {
		QueryPerformanceCounter(&m_swStop);
		if (m_swFreq.LowPart==0 && m_swFreq.HighPart==0) m_etime = -1;
		else {
			m_etime = (float)(m_swStop.LowPart - m_swStart.LowPart);
			if (m_etime < 0) m_etime += 2^32;
			m_etime /= (m_swFreq.LowPart+m_swFreq.HighPart * 2^32);
		}
	}
}
/**************************************/
void CDemoDoc::OnCximagePauseanimation() 
{
	if (image) image->mnginfo.animation_enabled=0;
}
/**************************************/
void CDemoDoc::OnCximageResumeanimation() 
{
	if ( image && image->mnginfo.thread==0 && image->mnginfo.animation){
		image->mnginfo.animation_enabled=1;
		DWORD dwID;
		image->mnginfo.thread = CreateThread(NULL,0,RunMNGThread,this,0,&dwID);
	}
}
/**************************************/
void CDemoDoc::OnCximageSinglestep() 
{
	if ( image && image->mnginfo.animation){
		image->mnginfo.animation_enabled=0;
		image->Resume();
		UpdateAllViews(NULL);
	}
}
/**************************************/
void CDemoDoc::OnCximagemngSpeedSlow() 
{
	if (image) image->mnginfo.speed = 0.5f;
}
/**************************************/
void CDemoDoc::OnCximagemngSpeedFast() 
{
	if (image) image->mnginfo.speed = 2.0f;
}
/**************************************/
void CDemoDoc::OnCximagemngSpeedNormal() 
{
	if (image) image->mnginfo.speed = 1.0f;
}
/**************************************/
void CDemoDoc::OnUpdateCximagePauseanimation(CCmdUI* pCmdUI) 
{	pCmdUI->Enable(image->mnginfo.animation);}
void CDemoDoc::OnUpdateCximageSinglestep(CCmdUI* pCmdUI) 
{	pCmdUI->Enable(image->mnginfo.animation);}
void CDemoDoc::OnUpdateCximageResumeanimation(CCmdUI* pCmdUI) 
{	pCmdUI->Enable(image->mnginfo.animation);}
/**************************************/
void CDemoDoc::OnUpdateCximageSettransparency(CCmdUI* pCmdUI) 
{	if (image) pCmdUI->Enable(1); else pCmdUI->Enable(0);}
void CDemoDoc::OnUpdateCximageRemovetransparency(CCmdUI* pCmdUI) 
{	if (image) pCmdUI->Enable(1); else pCmdUI->Enable(0);}
/**************************************/
void CDemoDoc::OnCximageSettransparency() 
{
	m_WaitingClick=TRUE;
}
/**************************************/
void CDemoDoc::OnCximageRemovetransparency() 
{
	if (image) image->SetTransIndex(-1);
	UpdateAllViews(NULL);
}
/**************************************/

